#ifndef LIST_H_
#define LIST_H_

struct slist {
	struct slist	*next;
	void		*data;
};

typedef int (*slistcallback_t)(void *data, void *opaque);

struct slist *slist_new();
void slist_free(struct slist **s);
void slist_free_all(struct slist **slist, void (*release)(void *data));
struct slist *slist_add(struct slist *slist, struct slist *e);
struct slist *slist_add_tail(struct slist *slist, struct slist *e);
struct slist *slist_extract(struct slist **slist);
struct slist *slist_unlink(struct slist *slist, struct slist *s);
struct slist *slist_reverse(struct slist *slist);
size_t slist_count(struct slist *slist);

struct slist *slist_find(struct slist *slist, const void *data,
			 int (*compare)(const void *a, const void *b));

void slist_traverse(struct slist *slist, slistcallback_t callback, void *opaque);


#endif /* LIST_H_ */
